/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

// AIMLpadDoc.cpp : implementation of the CAIMLpadDoc class
//

#include "stdafx.h"
#include "AIMLpad.h"

#include "AIMLpadDoc.h"

#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>
#include "string.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAIMLpadDoc

IMPLEMENT_DYNCREATE(CAIMLpadDoc, CDocument)

BEGIN_MESSAGE_MAP(CAIMLpadDoc, CDocument)
	//{{AFX_MSG_MAP(CAIMLpadDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAIMLpadDoc construction/destruction

CAIMLpadDoc::CAIMLpadDoc()
{
	// TODO: add one-time construction code here

}

CAIMLpadDoc::~CAIMLpadDoc()
{
}

BOOL CAIMLpadDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	((CEditView*)m_viewList.GetHead())->SetWindowText(NULL);

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CAIMLpadDoc serialization

void CAIMLpadDoc::Serialize(CArchive& ar)
{
	CEditView *myList = (CEditView*) m_viewList.GetHead();
	CEdit& edit = myList->GetEditCtrl();
	edit.SetLimitText(0);

	if (ar.IsStoring()) {
		myList->SerializeRaw(ar);
	} else {
		CFile* pFile = ar.GetFile();
		ASSERT(pFile->GetPosition() == 0);
		DWORD nFileSize = pFile->GetLength();
//		if (nFileSize > myList->nMaxSize) {
//			AfxMessageBox(AFX_IDP_FILE_TOO_LARGE);
//			AfxThrowUserException();
//		}
		ReadFromArchive(ar,(UINT)nFileSize);
	}
}

void CAIMLpadDoc::ReadFromArchive(CArchive& ar,UINT nLen)
{
	CEditView *myList = (CEditView*) m_viewList.GetHead();

	CString cstrText;
	char c;
	char *at;
	char *pos;
	UINT xLen = nLen + nLen + 4;
	UINT yLen;

	LPVOID hText = LocalAlloc(LMEM_MOVEABLE,nLen + 4);
	if (hText == NULL) AfxThrowMemoryException();
	LPSTR lpszText = (LPSTR)LocalLock(hText);
	ASSERT(lpszText != NULL);

	if (ar.Read(lpszText,nLen) != nLen) {
		LocalUnlock(hText);
		LocalFree(hText);
		AfxThrowArchiveException(CArchiveException::endOfFile);
		return;
	}
	lpszText[nLen + 1] = '\0';
	lpszText[nLen + 2] = '\0';

	for (at = lpszText;*at && *at != '\n';at++);
	if (*at) {
		LPVOID hxText = LocalAlloc(LMEM_MOVEABLE,xLen--);
		if (hxText == NULL) AfxThrowMemoryException();
		LPSTR szText = (LPSTR)LocalLock(hxText);
		ASSERT(szText != NULL);

		c = ' ';
		for (yLen = 0,pos = szText,at = lpszText;yLen < nLen;yLen++,at++) {
			if (*at == '\n') if (c != '\r') *pos++ = '\r';
			c = *at;
			*pos++ = c;
		}
		*pos++ = 0; *pos = 0;

		LocalUnlock(hText);
		LocalFree(hText);

		cstrText = szText;

		LocalUnlock(hxText);
		LocalFree(hxText);
	} else cstrText = lpszText;

//	cstrText.AnsiToOem();
	myList->SetWindowText(cstrText);

	LPCTSTR tmp = myList->LockBuffer();
	myList->UnlockBuffer();
}

/////////////////////////////////////////////////////////////////////////////
// CAIMLpadDoc diagnostics

#ifdef _DEBUG
void CAIMLpadDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAIMLpadDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAIMLpadDoc commands
