/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

// CmdDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "CmdDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCmdDlg dialog


CCmdDlg::CCmdDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCmdDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCmdDlg)
	m_command = _T("");
	m_status = _T("");
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CCmdDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCmdDlg)
	DDX_Text(pDX, IDC_COMMAND, m_command);
	DDV_MaxChars(pDX, m_command, 8192);
	DDX_Text(pDX, IDC_STATUS, m_status);
	DDV_MaxChars(pDX, m_status, 1024);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BOOL CCmdDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CWnd* pWnd = GetDlgItem(IDC_COMMAND);
	pWnd->SetFocus();

	return false;
}


BEGIN_MESSAGE_MAP(CCmdDlg, CDialog)
	//{{AFX_MSG_MAP(CCmdDlg)
	ON_EN_CHANGE(IDC_COMMAND, OnChangeCommand)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCmdDlg message handlers

void CCmdDlg::OnChangeCommand() 
{
	TCHAR szInput[8192];
	CWnd* pWnd = GetDlgItem(IDC_COMMAND);
	int iRet = pWnd->GetWindowText(szInput,8192);

	if (iRet-- > 0) {
		if (szInput[iRet] == '\n') {
			while (iRet >= 0) {
				if (szInput[iRet] > ' ') break;
				szInput[iRet--] = 0;
			}
			pWnd->SetWindowText(szInput);
			OnOK();
		}
	}
}
