/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

// FactDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "FactDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFactDlg dialog


CFactDlg::CFactDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFactDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFactDlg)
	m_cf = 0.0;
	m_source = _T("");
	m_tag = _T("");
	m_value = _T("");
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_mvId = 0;
}


void CFactDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFactDlg)
	DDX_Control(pDX, IDC_MVLIST, m_mvlist);
	DDX_Text(pDX, IDC_CF, m_cf);
	DDX_Text(pDX, IDC_SOURCE, m_source);
	DDX_Text(pDX, IDC_TAG, m_tag);
	DDX_Text(pDX, IDC_VALUE, m_value);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


void CFactDlg::SaveValue()
{
	char *buf;
	Fact *pFact = kb->curSub->m_cases.curCase->m_facts.curFact;

	if (m_mvId == 0) { 
		pFact->m_value = m_value;
	} else {
		POSITION pos = pFact->m_mvlist.FindIndex(m_mvId - 1);
		if (pos == NULL) {
			buf = new char[m_value.GetLength() + 2];
			sprintf(buf,"%s",m_value);
			pFact->Push(buf);
			delete buf;
		} else {
			pFact->m_mvlist.SetAt(pos,m_value);
		}
	}
}


void CFactDlg::FillList()
{
	CString str;
	Fact *pFact = kb->curSub->m_cases.curCase->m_facts.curFact;

	m_tag = pFact->m_attribute;
	m_cf = pFact->m_cf;
	m_source = pFact->m_source;
	m_value = pFact->m_value;

	m_mvlist.ResetContent();
	m_mvlist.AddString(m_value);

	POSITION pos = pFact->m_mvlist.GetHeadPosition();
	while (pos != NULL) {
		m_mvlist.AddString(pFact->m_mvlist.GetNext(pos));
	}
	m_mvlist.AddString(_T("<<add new value>>"));
	m_mvId = 0;

	UpdateData(false);
}


BOOL CFactDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	FillList();

	CWnd* pWnd = GetDlgItem(IDC_VALUE);
	pWnd->SetFocus();

	return false;
}


BEGIN_MESSAGE_MAP(CFactDlg, CDialog)
	//{{AFX_MSG_MAP(CFactDlg)
	ON_LBN_DBLCLK(IDC_MVLIST, OnDblclkMvlist)
	ON_LBN_SELCHANGE(IDC_MVLIST, OnSelchangeMvlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFactDlg message handlers

void CFactDlg::OnOK() 
{
	UpdateData(true);

	Fact *pFact = kb->curSub->m_cases.curCase->m_facts.curFact;

	pFact->m_cf = m_cf;
	pFact->m_source = m_source;
	SaveValue();

	if (m_mvId + 1 < m_mvlist.GetCount()) CDialog::OnOK(); else FillList();
}

void CFactDlg::OnDblclkMvlist() 
{
	UpdateData(true);

	int nIndex = m_mvlist.GetCurSel();
	Fact *pFact = kb->curSub->m_cases.curCase->m_facts.curFact;
	POSITION pos;

	if (nIndex != LB_ERR) {
		SaveValue();
		FillList();
		m_mvlist.GetText(nIndex,m_value);
		if (nIndex + 1 < m_mvlist.GetCount()) {
			if (MessageBox(_T("Ok to delete value?"),m_value,MB_YESNO) == IDYES) {
				if (nIndex) {
					pos = pFact->m_mvlist.FindIndex(nIndex - 1);
					if (pos != NULL) pFact->m_mvlist.RemoveAt(pos);
					FillList();
				} else {
					if (m_mvlist.GetCount() < 2) MessageBox(_T("Can't delete facts from this view."));
					else {
						m_value = pFact->m_mvlist.RemoveHead();
						pFact->m_value = m_value;
						FillList();
					}
				}
			} else {
				m_mvId = nIndex;
				m_mvlist.SetCurSel(nIndex);
			}
		}
	}
}

void CFactDlg::OnSelchangeMvlist() 
{
	int nIndex = m_mvlist.GetCurSel();

	if (nIndex != LB_ERR) {
		if (m_mvId != nIndex) {
			SaveValue();
			FillList();
		}
		m_mvlist.GetText(nIndex,m_value);
		m_mvId = nIndex;
		m_mvlist.SetCurSel(nIndex);
		UpdateData(false);
	}
}
