/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

// FrameDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "FrameDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFrameDlg dialog


CFrameDlg::CFrameDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFrameDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFrameDlg)
	m_frameid = _T("");
	m_script = _T("");
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CFrameDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFrameDlg)
	DDX_Text(pDX, IDC_FRAMEID, m_frameid);
	DDX_Text(pDX, IDC_SCRIPT, m_script);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BOOL CFrameDlg::OnInitDialog()
{
	Script *pScript = pgm->curScript;
	
	CDialog::OnInitDialog();

	m_script = "";
	if (!pgm->Seek(m_name)) pgm->curScript = pScript;
	if (pgm->curScript->m_frames.Seek(m_frameid)) {
		m_script = pgm->curScript->m_frames.curFrame->m_behavior;
	}
	pgm->curScript = pScript;

	UpdateData(false);

	CWnd* pWnd = GetDlgItem(IDC_FRAMEID);
	pWnd->SetFocus();

	m_modified = false;

	return false;
}


BEGIN_MESSAGE_MAP(CFrameDlg, CDialog)
	//{{AFX_MSG_MAP(CFrameDlg)
	ON_BN_CLICKED(IDC_FIND, OnFind)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_EN_CHANGE(IDC_SCRIPT, OnChangeScript)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFrameDlg message handlers

void CFrameDlg::OnFind() 
{
	Script *pScript = pgm->curScript;

	UpdateData(true);

	m_script = "";
	if (!pgm->Seek(m_name)) pgm->curScript = pScript;
	Frames *pFrames = &(pgm->curScript->m_frames);

	if (pFrames->Seek(m_frameid)) m_script = pFrames->curFrame->m_behavior;

	pgm->curScript = pScript;

	UpdateData(false);
}

void CFrameDlg::OnSave() 
{
	Script *pScript = pgm->curScript;

	UpdateData(true);

	if (!pgm->Seek(m_name)) pgm->curScript = pScript;
	Frames *pFrames = &(pgm->curScript->m_frames);

	if (pFrames->Seek(m_frameid)) {
		if (m_script.IsEmpty()) {
			if (MessageBox(_T("Ok to delete frame?"),m_frameid,MB_YESNO) == IDYES) {
				char *buf = new char[m_frameid.GetLength() + 2];
				sprintf(buf,"%s",m_frameid);
				pFrames->Remove(buf);
				delete buf;
			}
		} else pFrames->curFrame->m_behavior = m_script;
	} else {
		pFrames->Key = m_name;
		pFrames->curFrame = new Frame();

		pFrames->curFrame->m_name = m_frameid;
		pFrames->curFrame->m_behavior = m_script;
		
		Frame *pTemp = pFrames->m_mapStringToFrame[m_frameid];
		delete pTemp;

		pFrames->m_mapStringToFrame[m_frameid] = pFrames->curFrame;
		pFrames->At = NULL;
	}
	pgm->curScript = pScript;

	UpdateData(false);
}

void CFrameDlg::OnChangeScript() 
{
	m_modified = true;	
}
