/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

#if !defined(AFX_LEARNDLG_H__951C870B_7B21_417D_A886_A8355B04457F__INCLUDED_)
#define AFX_LEARNDLG_H__951C870B_7B21_417D_A886_A8355B04457F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "support.h"

// LearnDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CLearnDlg dialog

class CLearnDlg : public CDialog
{
// Construction
public:
	CLearnDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CLearnDlg();			   // standard destructor

	int prepareaiml(char *dir,char *fname,char *atfn,int iMerge,int iList);
	int foreachaiml(char *dir,char *fname,char *atfn,int iList);
	void sortaiml();
	int cleanupaiml();
	void sortforstandardaiml();
	void reindex();
	void mergecategories();

// Dialog Data
	//{{AFX_DATA(CLearnDlg)
	enum { IDD = IDD_LEARN };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	BOOL OnInitDialog();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLearnDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
private:
	long splitup(char *src);
	void replacer(char *line);
	int checkline(char *line);

	char *topic;

	int cc;
	int hp;
	int hh;
	int he;
	int convertversion;

	bool blnThinking;

protected:

	// Generated message map functions
	//{{AFX_MSG(CLearnDlg)
	virtual void OnOK();
	afx_msg void OnLearnBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LEARNDLG_H__951C870B_7B21_417D_A886_A8355B04457F__INCLUDED_)
