// RuleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "RuleDlg.h"
#include "rules.h"
#include "WhyDlg.h"
#include "support.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRuleDlg dialog


CRuleDlg::CRuleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRuleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRuleDlg)
	m_ruleid = _T("");
	m_specs = _T("");
	//}}AFX_DATA_INIT
}


void CRuleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRuleDlg)
	DDX_Text(pDX, IDC_RULEID, m_ruleid);
	DDX_Text(pDX, IDC_SPECS, m_specs);
	//}}AFX_DATA_MAP
}


BOOL CRuleDlg::OnInitDialog() 
{
	Rule *pRule;

	CDialog::OnInitDialog();

	m_specs = _T("");
	if (xpt->m_mapStringToRule.Lookup(m_ruleid,pRule)) pRule->SpecRule(m_specs);

	UpdateData(false);

	CWnd* pWnd = GetDlgItem(IDC_RULEID);
	pWnd->SetFocus();

	return false;
}


BEGIN_MESSAGE_MAP(CRuleDlg, CDialog)
	//{{AFX_MSG_MAP(CRuleDlg)
	ON_BN_CLICKED(IDC_FIND, OnFind)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_WHAT, OnWhat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRuleDlg message handlers

void CRuleDlg::OnFind() 
{
	Rule *pRule;

	UpdateData(true);

	m_specs = _T("");
	if (xpt->m_mapStringToRule.Lookup(m_ruleid,pRule)) pRule->SpecRule(m_specs);

	UpdateData(false);
}

void CRuleDlg::OnSave() 
{
	char rule[128];
	char subj[128];
	Rule *pRule;
	char *buf;
	char *a, *v;
	char r[5];
	char *i, *j, *k;
	double cf;

	UpdateData(true);

	if (xpt->m_mapStringToRule.Lookup(m_ruleid,pRule)) {
		if (m_specs.IsEmpty()) {
			if (MessageBox(_T("Ok to delete rule?"),m_ruleid,MB_YESNO) == IDYES) {
				delete pRule;
				m_ruleid = _T("");
				UpdateData(false);
				return;
			}
		}
		sprintf(subj,"%s",pRule->m_subject);
	} else *subj = 0;
	buf = new char[m_specs.GetLength() + 2];
	sprintf(buf,"%s",m_specs);
	for (i = buf;*i && *i <= ' ';i++);
	if (strnicmp(i,"if",2)) {
		MessageBox(_T("Missing 'If' clause to create premises. Rule invalid!"));
	} else {
		if (!stristr(buf,"then")) {
			MessageBox(_T("Missing 'Then' clause to create results. Rule won't work!"));
		} else {
			sprintf(rule,"%s",m_ruleid);
			xpt->Add(rule,subj);
			for (i += 2;*i && *i <= ' ';i++);
			while (*i && strnicmp(i,"then",4)) {
				for (a = i;*i && *i != '<' && *i != '=' && *i != '>' && *i != '!';i++);
				if (*i) for (j = i - 1;j > a && *j <= ' ';j--) *j = 0;
				for (j = r,k = i;*i == '<' || *i == '=' || *i == '>' || *i == '!';i++) *j++ = *i; *j = 0;
				while (*k && *k <= ' ') *k-- = 0;
				while (*i && *i <= ' ') i++;
				for (v = i;*i && *i > ' ';i++);;
				if (*i) for (*i++ = 0;*i && *i <= ' ';*i++ = 0);
				xpt->curRule->AddPremise(a,r,v);
			}
			if (*i) {
				for (i += 4;*i && *i <= ' ';i++);
				while (*i) {
					for (a = i;*i && *i != '=';i++);
					if (!*i) break;
					k = i - 1;
					*i++ = 0;
					while (*k == ' ') *k-- = 0;
					if (*k == '%') {
						*k-- = 0;
						while (k >= a && isdigit(*k)) k--;
						cf = atof(k + 1) / 100;
						while (k >= a && isspace(*k)) k--;
						*(k + 1) = 0;
					} else cf = 1.0;
					for (v = i;*i && *i >= ' ';i++);
					if (*i) *i++ = 0;
					while (*i && *i <= ' ') i++;
					xpt->curRule->AddResult(a,v,cf);
				}
			}
		}
	}
	delete buf;

	UpdateData(false);
}

void CRuleDlg::OnWhat() 
{
	CWhyDlg *why = new CWhyDlg;

	UpdateData(true);
	xpt->What(m_ruleid,why->m_reason);

	why->DoModal();
	delete why;
}
