/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

// ScriptDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "ScriptDlg.h"
#include "FrameDlg.h"
#include "pu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScriptDlg dialog


CScriptDlg::CScriptDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScriptDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScriptDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CScriptDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScriptDlg)
	DDX_Control(pDX, IDC_TREE, m_tree);
	//}}AFX_DATA_MAP
}


void CScriptDlg::FillTree()
{
	int i;
	int cnt;
	CString skey;
	POSITION spos;
	Script *pScript;
	HTREEITEM hScript;
	POSITION fpos;
	CTreeCtrl *pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE);
	
	pTree->DeleteAllItems();

	hScript = pTree->InsertItem(_T("*** Pose New Script ***"),TVI_ROOT,TVI_SORT);

	spos = pgm->m_mapStringToScript.GetStartPosition();
	while (spos != NULL) {
		pgm->m_mapStringToScript.GetNextAssoc(spos,skey,pScript);
		hScript = pTree->InsertItem(pScript->m_name,TVI_ROOT,TVI_SORT);
		cnt = pScript->m_frameslist.GetCount();
		for (i = 0;i < cnt;i++) {
			fpos = pScript->m_frameslist.FindIndex(i);
			if (fpos == NULL) continue;
			pTree->InsertItem(pScript->m_frameslist.GetAt(fpos),hScript,TVI_LAST);
		}
	}

	UpdateData(false);
}


BOOL CScriptDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	FillTree();

	CWnd* pWnd = GetDlgItem(IDC_TREE);
	pWnd->SetFocus();

	return false;
}


BEGIN_MESSAGE_MAP(CScriptDlg, CDialog)
	//{{AFX_MSG_MAP(CScriptDlg)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE, OnDblclkTree)
	ON_NOTIFY(NM_RCLICK, IDC_TREE, OnRclickTree)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScriptDlg message handlers

void CScriptDlg::OnDblclkTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	char *fn;
	CString szFilter = "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";
	CString scriptname;
	CFrameDlg *framed;

	CTreeCtrl *pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE);
	HTREEITEM hItem = pTree->GetSelectedItem();
	if (hItem != NULL) {
		if(!pTree->ItemHasChildren(hItem)) {
			scriptname = pTree->GetItemText(hItem);
			if (scriptname.Compare(_T("*** Pose New Script ***"))) {
				framed = new CFrameDlg;
				framed->pgm = pgm;
				framed->m_name = pTree->GetItemText(pTree->GetParentItem(hItem));
				framed->m_frameid = pTree->GetItemText(hItem);
				if (framed->DoModal() == IDOK) FillTree();
				delete framed;
			} else {
				CFileDialog dlg(true, _T("txt"), NULL, OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilter, NULL);
				dlg.m_ofn.lpstrTitle = TEXT("Load Script From File...");
				if (dlg.DoModal() != IDCANCEL)	{
					fn  = new char[MAX_PATH_LEN];
					sprintf(fn,"\"%s\"",dlg.GetPathName());
					pu->utpose(fn);
					delete fn;
					FillTree();
				}
				delete dlg;
			}
		}
	}
	*pResult = 0;
}

void CScriptDlg::OnRclickTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString scriptname;
	char sn[MAX_PATH_LEN];

	CTreeCtrl *pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE);
	HTREEITEM hItem = pTree->GetSelectedItem();
	if (hItem != NULL) if(pTree->ItemHasChildren(hItem)) {
		scriptname = pTree->GetItemText(hItem);
		if (scriptname.Compare(_T("*** Pose New Script ***"))) {
			if (MessageBox(_T("Ok to rescind (delete) script?"),scriptname,MB_YESNO) == IDYES) {
				sprintf(sn,"%s",scriptname);
				pgm->Remove(sn);
				FillTree();
			}
		}
	}
	*pResult = 0;
}
