// TargetDlg.cpp : implementation file
//

#include "stdafx.h"
#include <afxwin.h>

#include "AIMLpad.h"
#include "TargetDlg.h"
#include "core.h"
#include "pu.h"
#include "support.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTargetDlg dialog


CTargetDlg::CTargetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTargetDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTargetDlg)
	m_scrollbar = 0;
	//}}AFX_DATA_INIT
	intAtTarget = 0;
}


void CTargetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTargetDlg)
	DDX_Scroll(pDX, IDC_SCROLLBAR1, m_scrollbar);
	//}}AFX_DATA_MAP
}


void CTargetDlg::formatTemplate(char *s)
{
	char *i;
	char *pos;
	char *buf = new char[MAX_BUF_LEN];

	for (i = s,pos = buf;*i;i++) {
		if (!strncmp(i,"<random>",8)      || !strncmp(i,"<condition>",11) ||
			!strncmp(i,"</condition>",12) || !strncmp(i,"</random>",9)    ||
			!strncmp(i,"</li>",5)         || !strncmp(i,"</save>",7)      ||
			!strncmp(i,"</think>",8)      || !strncmp(i,"</system>",9)    ||
			!strncmp(i,"</gossip>",9)     || !strncmp(i,"<br/>",5)        ||
			!strncmp(i,"<BR/>",5)         || !strncmp(i,"<usesaved/>",11)) {
			while (*i != '>') *pos++ = *i++;
			*pos++ = *i;
			*pos++ = '\r';
			*pos++ = '\n';
		} else *pos++ = *i;
	}
	*pos = 0;
	strcpy(s,buf);
	delete buf;
}


void CTargetDlg::FillForm()
{
	CString str;
	bool blnInput;
	char *line = new char[MAX_BUF_LEN];
	int chk = GetCheckedRadioButton(IDC_RADREPLY,IDC_RADTEMP);
	char *at;
	int intCnt = intCntTargets;

	intCntTargets = 0;
	FILE *tfile = fopen(bot->fntar,"r");
	if (tfile) {
		while (fgets(line,MAX_BUF_LEN,tfile)) {
			rtrim(line);
			for (at = line;*at && isspace(*at);at++);
			if (!strcmp(at,"<target>")) intCntTargets++;
			else if (intCntTargets == intAtTarget) {
				if (!strcmp(at,"<input>")) blnInput = true;
				else if (!strcmp(at,"<match>")) blnInput = false;
				else if (!strncmp(at,"<text>",6)) {
					replace(at,"</text>","");
					str = at + 6;
					SetDlgItemText(IDC_EDITINPUTTEXT,str);
				} else if (!strncmp(at,"<pattern>",9)) {
					replace(at,"</pattern>","");
					str = at + 9;
					SetDlgItemText(IDC_EDITMATCHPAT,str);
					SetDlgItemText(IDC_EDITCATPAT,str);
				} else if (!strncmp(at,"<that>",6)) {
					replace(at,"</that>","");
					str = at + 6;
					if (blnInput) SetDlgItemText(IDC_EDITINPUTTHAT,str);
					else {
						SetDlgItemText(IDC_EDITMATCHTHAT,str);
						SetDlgItemText(IDC_EDITCATTHAT,str);
					}
				} else if (!strncmp(at,"<topic>",7)) {
					replace(at,"</topic>","");
					str = at + 7;
					if (blnInput) SetDlgItemText(IDC_EDITINPUTTOPIC,str);
					else {
						SetDlgItemText(IDC_EDITMATCHTOPIC,str);
						SetDlgItemText(IDC_EDITCATTOPIC,str);
					}
				} else if (!strncmp(at,"<template>",10)) {
					replace(at,"</template>","");
					formatTemplate(at);
					Template = at + 10;
					if (chk == IDC_RADTEMP) SetDlgItemText(IDC_EDITREPLYTEXT,Template);
				} else if (!strncmp(at,"<reply>",7)) {
					replace(at,"</reply>","");
					Reply = at + 7;
					if (chk == IDC_RADREPLY) SetDlgItemText(IDC_EDITREPLYTEXT,Reply);
				}
			}
		}
		fclose(tfile);
	} else {
		str = "*";
		SetDlgItemText(IDC_EDITCATTHAT,str);
		SetDlgItemText(IDC_EDITCATTOPIC,str);
		str = "";
		SetDlgItemText(IDC_EDITCATPAT,str);
		SetDlgItemText(IDC_EDITREPLYTEXT,str);
	}
	delete line;

	str.Format(_T("%d targets"),intCntTargets);
	SetDlgItemText(IDC_TARGETS_COUNT,str);
	str.Format(_T("At %d"),intAtTarget);
	SetDlgItemText(IDC_TARGETS_AT,str);

	if (intCnt != intCntTargets) {
		CScrollBar *sb = (CScrollBar *)GetDlgItem(IDC_SCROLLBAR1);
		sb->SetScrollRange(1,intCntTargets);
	}
	UpdateData(false);
}


BOOL CTargetDlg::OnInitDialog() 
{
	CString str;

	CDialog::OnInitDialog();	

	if (intCntTargets < 0 && intAtTarget < 0) {
		CheckRadioButton(IDC_RADREPLY,IDC_RADTEMP,IDC_RADTEMP);
		SetDlgItemText(IDC_EDITMATCHPAT,m_Pattern);
		SetDlgItemText(IDC_EDITMATCHTHAT,m_That);
		SetDlgItemText(IDC_EDITMATCHTOPIC,m_Topic);
		SetDlgItemText(IDC_EDITCATPAT,m_Pattern);
		SetDlgItemText(IDC_EDITCATTHAT,m_That);
		SetDlgItemText(IDC_EDITCATTOPIC,m_Topic);
		SetDlgItemText(IDC_EDITREPLYTEXT,Template);
	} else {
		if (intAtTarget <= 0) intAtTarget = 1;
		intCntTargets = 0;

		CheckRadioButton(IDC_RADREPLY,IDC_RADTEMP,IDC_RADREPLY);
		FillForm();
	}
	GetDlgItem(IDC_EDITREPLYTEXT)->SetFocus();
	
	return FALSE;
}


void CTargetDlg::SaveAs(bool updt) 
{
	DWORD parms;
	if (updt) parms = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	else parms = OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;

	CString szFilter = "AIML Files (*.aiml)|*.aiml|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";
	CFileDialog dlg(false, _T("aiml"), m_fname, parms, szFilter, NULL);
	char *fn = new char[MAX_PATH_LEN];

	if (updt) dlg.m_ofn.lpstrTitle = TEXT("Replace Category In File...");
	else dlg.m_ofn.lpstrTitle = TEXT("Save Category In File...");

	if (dlg.DoModal() == IDCANCEL)	return;

	sprintf(fn,"%s",dlg.GetPathName());

	CString str;
	char *tmp = new char[MAX_BUF_LEN];
	char *pat = new char[MAX_BUF_LEN];
	int chk = GetCheckedRadioButton(IDC_RADREPLY,IDC_RADTEMP);

	if (chk == IDC_RADREPLY) {
		GetDlgItemText(IDC_EDITREPLYTEXT,Reply);
		Template = Reply;
	}
	if (chk == IDC_RADTEMP)  GetDlgItemText(IDC_EDITREPLYTEXT,Template);

	if (updt) {
		GetDlgItemText(IDC_EDITCATPAT,str);
		sprintf(pat,"%s",str);
		GetDlgItemText(IDC_EDITCATTHAT,str);
		sprintf(tmp,"%s",str);
		if (*tmp && strcmp(tmp,"*")) { strcat(pat,"<that>"); strcat(pat,tmp); }
		GetDlgItemText(IDC_EDITCATTOPIC,str);
		sprintf(tmp,"%s",str);
		if (*tmp && strcmp(tmp,"*")) { strcat(pat,"<topic>"); strcat(pat,tmp); }
		pu->savslot("BotDBOriginal",pat);
	}

	GetDlgItemText(IDC_EDITCATPAT,str);
	sprintf(pat,"%s",str);
	GetDlgItemText(IDC_EDITCATTHAT,str);
	sprintf(tmp,"%s",str);
	if (*tmp && strcmp(tmp,"*")) { strcat(pat,"<that>"); strcat(pat,tmp); }
	GetDlgItemText(IDC_EDITCATTOPIC,str);
	sprintf(tmp,"%s",str);
	if (*tmp && strcmp(tmp,"*")) { strcat(pat,"<topic>"); strcat(pat,tmp); }
	pu->savslot("BotDBPattern",pat);

	if (Template.IsEmpty()) {
		sprintf(tmp,"%s",Reply);
		while (replace(tmp,"\r\n"," "));
	} else {
		sprintf(tmp,"%s",Template);
		while (replace(tmp,"\r\n",""));
	}
	pu->savslot("BotDBTemplate",tmp);

	if (updt) {
		sprintf(tmp,"$BotDBOriginal $BotDBPattern $BotDBTemplate \"%s\"",fn);
		pu->utrwrite(tmp);
	} else {
		sprintf(tmp,"$BotDBPattern $BotDBTemplate \"%s\"",fn);
		pu->utwrite(tmp);
	}

	delete tmp;
	delete pat;
	delete fn;
}


BEGIN_MESSAGE_MAP(CTargetDlg, CDialog)
	//{{AFX_MSG_MAP(CTargetDlg)
	ON_BN_CLICKED(IDC_BTNCLEAR, OnBtnclear)
	ON_BN_CLICKED(IDC_BTNDISCARD, OnBtndiscard)
	ON_BN_CLICKED(IDC_BTNDROP, OnBtndrop)
	ON_BN_CLICKED(IDC_BTNNEXT, OnBtnnext)
	ON_BN_CLICKED(IDC_BTNRANDOM, OnBtnrandom)
	ON_BN_CLICKED(IDC_BTNREDUCE, OnBtnreduce)
	ON_BN_CLICKED(IDC_BTNSAVE, OnBtnsave)
	ON_BN_CLICKED(IDC_BTNSR, OnBtnsr)
	ON_BN_CLICKED(IDC_BTNSRAI, OnBtnsrai)
	ON_BN_CLICKED(IDC_BTNTHINK, OnBtnthink)
	ON_BN_CLICKED(IDC_RADREPLY, OnRadreply)
	ON_BN_CLICKED(IDC_RADTEMP, OnRadtemp)
	ON_BN_CLICKED(IDC_BTNAdd, OnBTNAdd)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BTNSAVEAS, OnBtnsaveas)
	ON_BN_CLICKED(IDC_BTNREPLACE, OnBtnreplace)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTargetDlg message handlers

void CTargetDlg::OnBtnclear() 
{
	CString str = "";

	intAtTarget = 0;
	SetDlgItemText(IDC_EDITINPUTTEXT,str);
	SetDlgItemText(IDC_EDITINPUTTHAT,str);
	SetDlgItemText(IDC_EDITINPUTTOPIC,str);
	SetDlgItemText(IDC_EDITMATCHPAT,str);
	SetDlgItemText(IDC_EDITMATCHTHAT,str);
	SetDlgItemText(IDC_EDITMATCHTOPIC,str);
	SetDlgItemText(IDC_EDITCATPAT,str);
	SetDlgItemText(IDC_EDITCATTHAT,str);
	SetDlgItemText(IDC_EDITCATTOPIC,str);
	SetDlgItemText(IDC_EDITREPLYTEXT,str);
	Template = str;
	Reply = str;
	str.Format(_T("At %d"),intAtTarget);
	SetDlgItemText(IDC_TARGETS_AT,str);
	CheckRadioButton(IDC_RADREPLY,IDC_RADTEMP,IDC_RADREPLY);
	CScrollBar *sb = (CScrollBar *)GetDlgItem(IDC_SCROLLBAR1);
	sb->SetScrollPos(1);
}

void CTargetDlg::OnBtnrandom() 
{
	CString str;

	CheckRadioButton(IDC_RADREPLY,IDC_RADTEMP,IDC_RADTEMP);
	OnRadtemp();
	str = "<random>\r\n<li>" + Template + "</li>\r\n</random>";
	SetDlgItemText(IDC_EDITREPLYTEXT,str);	
}

void CTargetDlg::OnBtnsr() 
{
	CString str;

	CheckRadioButton(IDC_RADREPLY,IDC_RADTEMP,IDC_RADTEMP);
	OnRadtemp();
	str = Template + "<sr/>";
	SetDlgItemText(IDC_EDITREPLYTEXT,str);	
}

void CTargetDlg::OnBtnsrai() 
{
	CString str;

	CheckRadioButton(IDC_RADREPLY,IDC_RADTEMP,IDC_RADTEMP);
	OnRadtemp();
	str = "<srai>\r\n" + Template + "\r\n</srai>";
	SetDlgItemText(IDC_EDITREPLYTEXT,str);	
}

void CTargetDlg::OnBtnthink() 
{
	CString str;

	CheckRadioButton(IDC_RADREPLY,IDC_RADTEMP,IDC_RADTEMP);
	OnRadtemp();
	str = "<think>\r\n" + Template + "\r\n</think>";
	SetDlgItemText(IDC_EDITREPLYTEXT,str);	
}

void CTargetDlg::OnBtnreduce() 
{
	CString str;
	CString inp;
	CString pat;
	CString cat;
	int pos;
	int npos;

	GetDlgItemText(IDC_EDITINPUTTEXT,inp);	
	GetDlgItemText(IDC_EDITMATCHPAT,pat);

	pos = pat.Find('*');
	if (pos < 1) return;
	npos = inp.Find(' ',pos);
	if (npos < 0) cat = inp; else cat = inp.Left(npos) + " *";
	pat = pat.Left(pos - 1) + " <sr/>";

	SetDlgItemText(IDC_EDITCATPAT,cat);	

	CheckRadioButton(IDC_RADREPLY,IDC_RADTEMP,IDC_RADTEMP);
	OnRadtemp();
	str = "<srai>\r\n" + pat + "\r\n</srai>\r\n" + Template;
	SetDlgItemText(IDC_EDITREPLYTEXT,str);	
}

void CTargetDlg::OnRadreply() 
{
	GetDlgItemText(IDC_EDITREPLYTEXT,Template);
	SetDlgItemText(IDC_EDITREPLYTEXT,Reply);
}

void CTargetDlg::OnRadtemp() 
{
	GetDlgItemText(IDC_EDITREPLYTEXT,Reply);
	SetDlgItemText(IDC_EDITREPLYTEXT,Template);
}

void CTargetDlg::OnBtndiscard() 
{
	if (intCntTargets <= 0) return;

	TCHAR szFileName[MAX_PATH_LEN];
	TCHAR szOldFileName[MAX_PATH_LEN];
	char *line = new char[MAX_BUF_LEN];
	char *buf = new char[MAX_BUF_LEN];
	char *at;
	int intAt = intAtTarget;
	int cnt = 0;
	int iRet;

	if (MessageBox(TEXT("Ok to delete current target from log file?"),TEXT("Delete target confirmation"),MB_YESNO) == IDNO) return;
	FILE *tfile = fopen(bot->fntar,"r");
	if (!tfile) return;
	FILE *xfile = fopen(bot->fnwrk,"w");
	while (fgets(buf,MAX_BUF_LEN,tfile)) {
		strcpy(line,buf);
		rtrim(line);
		for (at = line;*at && isspace(*at);at++);
		if (!strcmp(at,"<target>")) cnt++;
		if (cnt != intAt) fputs(buf,xfile); 
	}
	fclose(tfile);
	fclose(xfile);

	wsprintf(szFileName,TEXT("%hs"),bot->fntar);
	wsprintf(szOldFileName,TEXT("%hs"),bot->fnwrk);

	iRet = DeleteFile(szFileName);
	iRet = MoveFile(szOldFileName,szFileName);

	OnBtnclear();
	if (intAt < intCntTargets) intAtTarget = intAt;
	FillForm();

	delete line;
}

void CTargetDlg::OnBtndrop() 
{
	if (intCntTargets <= 0) return;
	if (MessageBox(TEXT("Are your sure you want to empty the targets log file?"),TEXT("Delete file confirmation"),MB_YESNO) == IDNO) return;
	FILE *tfile = fopen(bot->fntar,"w");
	fclose(tfile);
	OnBtnclear();
	FillForm();
}

void CTargetDlg::OnBtnsave() 
{
	CString str;
	char *s = new char[MAX_BUF_LEN];
	int chk = GetCheckedRadioButton(IDC_RADREPLY,IDC_RADTEMP);
	bool blnTopic = false;

	if (chk == IDC_RADREPLY) {
		GetDlgItemText(IDC_EDITREPLYTEXT,Reply);
		Template = Reply;
	}
	if (chk == IDC_RADTEMP)  GetDlgItemText(IDC_EDITREPLYTEXT,Template);

	GetDlgItemText(IDC_EDITCATTOPIC,str);
	sprintf(s,"%s",str);
	if (*s && strcmp(s,"*")) {
		blnTopic = true;
		pu->pppost("<topic name=\"",s,"\">\r\n");
	}	
	pu->post("<category>\r\n");
	GetDlgItemText(IDC_EDITCATPAT,str);
	sprintf(s,"<pattern>%s</pattern>\r\n",str);
	pu->post(s);
	GetDlgItemText(IDC_EDITCATTHAT,str);
	sprintf(s,"%s",str);
	if (*s && strcmp(s,"*")) pu->pppost("<that>",s,"</that>\r\n");
	if (Template.IsEmpty()) sprintf(s,"<template>%s</template>\r\n",Reply);
	else sprintf(s,"<template>\r\n%s\r\n</template>\r\n",Template);
	pu->ppost(s,"</category>\r\n");
	if (blnTopic) pu->post("</topic>\r\n");
	delete s;
}

void CTargetDlg::OnBTNAdd() 
{
	CString str;
	char *tmp = new char[MAX_BUF_LEN];
	char *pat = new char[MAX_BUF_LEN];
	int chk = GetCheckedRadioButton(IDC_RADREPLY,IDC_RADTEMP);

	if (chk == IDC_RADREPLY) {
		GetDlgItemText(IDC_EDITREPLYTEXT,Reply);
		Template = Reply;
	}
	if (chk == IDC_RADTEMP)  GetDlgItemText(IDC_EDITREPLYTEXT,Template);

	GetDlgItemText(IDC_EDITCATPAT,str);
	sprintf(pat,"%s",str);
	GetDlgItemText(IDC_EDITCATTHAT,str);
	sprintf(tmp,"%s",str);
	if (*tmp && strcmp(tmp,"*")) { strcat(pat,"<that>"); strcat(pat,tmp); }
	GetDlgItemText(IDC_EDITCATTOPIC,str);
	sprintf(tmp,"%s",str);
	if (*tmp && strcmp(tmp,"*")) { strcat(pat,"<topic>"); strcat(pat,tmp); }

	if (Template.IsEmpty()) {
		sprintf(tmp,"%s",Reply);
		while (replace(tmp,"\r\n"," "));
	} else {
		sprintf(tmp,"%s",Template);
		while (replace(tmp,"\r\n",""));
	}

	pu->savslot("BotDBPattern",pat);
	pu->savslot("BotDBTemplate",tmp);
	pu->utcat("$BotDBPattern $BotDBTemplate");

	delete tmp;
	delete pat;
}

void CTargetDlg::OnBtnnext() 
{
	if (intCntTargets <= 0) return;
	if (intAtTarget < intCntTargets) intAtTarget++;
	FillForm();
	CScrollBar *sb = (CScrollBar *)GetDlgItem(IDC_SCROLLBAR1);
	sb->SetScrollPos(intAtTarget);
}

void CTargetDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UINT pos = nPos;
	UINT cd = nSBCode;

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);

	if (intCntTargets <= 0) return;
	switch (cd) {
		case SB_LINELEFT: if (intAtTarget > 1) intAtTarget--; FillForm(); break;
		case SB_LINERIGHT: if (intAtTarget < intCntTargets) intAtTarget++; FillForm(); break;
		case SB_PAGELEFT: if (intAtTarget > 10) intAtTarget -= 10; FillForm(); break;
		case SB_PAGERIGHT: if (intAtTarget < intCntTargets - 10) intAtTarget += 10; FillForm(); break;
		case SB_THUMBPOSITION: intAtTarget = pos; FillForm(); break;
	}
	if ((int)nPos != intAtTarget) pScrollBar->SetScrollPos(intAtTarget);
}

void CTargetDlg::OnBtnsaveas() 
{
	SaveAs(false);
}

void CTargetDlg::OnBtnreplace() 
{
	SaveAs(true);
}
