/* Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

// AskDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "AskDlg.h"

#include "support.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAskDlg dialog


CAskDlg::CAskDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAskDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAskDlg)
	m_prompt = _T("");
	m_reply = _T("");
	m_why = false;
	//}}AFX_DATA_INIT
}


void CAskDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAskDlg)
	DDX_Text(pDX, IDC_PROMPT, m_prompt);
	DDX_Text(pDX, IDC_REPLY, m_reply);
	//}}AFX_DATA_MAP
}


BOOL CAskDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CWnd* pWnd = GetDlgItem(IDC_REPLY);
	pWnd->SetFocus();

	return false;
}


BEGIN_MESSAGE_MAP(CAskDlg, CDialog)
	//{{AFX_MSG_MAP(CAskDlg)
	ON_BN_CLICKED(IDC_WHY, OnWhy)
	ON_EN_CHANGE(IDC_REPLY, OnChangeReply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAskDlg message handlers

void CAskDlg::OnChangeReply() 
{
	TCHAR szInput[MAX_BUF_LEN];
	CWnd* pWnd = GetDlgItem(IDC_REPLY);
	int iRet = pWnd->GetWindowText(szInput,MAX_BUF_LEN);

	if (iRet-- > 0) {
		if (szInput[iRet] == '\n') {
			while (iRet >= 0) {
				if (szInput[iRet] > ' ') break;
				szInput[iRet--] = 0;
			}
			pWnd->SetWindowText(szInput);
			OnOK();
		}
	}
}

void CAskDlg::OnWhy() 
{
	m_why = true;
	OnOK();
}
