/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 * Copyright (c) 2003-2004, Kino Coursey (Mods for CyN)
 *
 * This file is part of AIMLpad.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * AIMLpad is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with AIMLpad; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

// pu.h: interface for the PUvm class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __INC_PUVM_H__
#define __INC_PUVM_H__

#include <afx.h>
#include <afxwin.h>
#include <afxinet.h>   
#include <windows.h>
#include <winsock.h>
#include "facts.h"
#include "scripts.h"
#include "rules.h"
#include "core.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdlib.h"
#include "stdio.h"
#include "string.h"
#include "math.h"

#include "support.h"

extern void SpeakMSAgent(LPCSTR pszA);

class Core;

class PUvm  
{
public:
	PUvm();
	virtual ~PUvm();
	
// Attributes
public:
	Subjects kb;
	Scripts pgm;
	Rules xpt;
	Attributes atr;

	CEditView *host;
	Core *bot;

	bool blnInput;
	DWORD dwAtSel;

	char *fnpgm;
	char *fnrul;
	char *fnkb;
	char *fnstop;
	char *fnmname;
	char *fnfname;
	char *fnbadwd;
	
	char *startup;
	bool startbot;
	char *urlcycget;
	char *urlcycput;

// Implementation
public:
	bool onCmd(CString str);
	bool resume(char *str);

	int utattrs(char *at);
	int utbot(char *at);
	int utbrk(char *at);
	int utcalc(char *at);
	int utcases(char *at);
	int utcat(char *at);
	int utclear();
	int utconsdr(char *at);
	int utcopy();
	int utcut();
	int utdb(char *at);
	int utdeclar(char *at);
	int utdefine(char *at);
	int utdetermine(char *at);
	int utdiscrd();
	int utdrop(char *at);
	int uteop();
	int uterase();
	int uteval(char *at);
	int utexit(char *at);
	int utexport(char *at);
	int utextract(char *at);
	int utfacts(char *at);
	int utfind(char *at);
	int utframe(char *at);
	int utget(char *at);
	int utgetbot(char *at);
	int utgm(char *at);
	int uthome();
	int uthow(char *at);
	int utignore(char *at);
	int utimport(char *at);
	int utinsert(char *at);
	int utkill(char *at);
	int utload(char *at);
	int utmake(char *at);
	int utmatch(char *at);
	int utnorm(char *at);
	int utopen(char *at);
	int utpaste();
	int utpin(char *at);
	int utpop(char *at);
	int utpos(char *at);
	char *utpose(char *at);
	int utpost(char *at);
	int utpush(char *at);
	int utput(char *at);
	int utqueue(char *at);
	int utquit(char *at);
	int utread(char *at);
	int utrecall(char *at);
	int utremove(char *at);
	int utrescnd(char *at);
	int utrstart(char *at);
	int utrules(char *at);
	int utrule(char *at);
	int utrwrite(char *at);
	int utsave(char *at);
	int utsaveas(char *at);
	int utsay(char *at);
	int utscript(char *at);
	int utsearch(char *at);
	int utsel(char *at);
	int utsense(char *at);
	int utsentence(char *at);
	int utsetbot(char *at);
	int utshare(char *at);
	int utshow(char *at);
	int utsubjects(char *at);
	int utsubmit(char *at);
	int utsynonym(char *at);
	int uturl(char *at);
	int uturlclient(char *at);
	int utcycclient(char *at);
	int utuse(char *at);
	int utwhat(char *at);
	int utwhich(char *at);
	int utword(char *at);
	int utwrite(char *at);

	int classifyaiml(char *fn);
	int convertaiml(char *fn);
	int converttargets(char *fn);

	bool getslot(char *tag,char *val);
	bool savslot(char *tag,char *val);
	bool gblslot(char *tag,char *val);
	bool shrslot(char *tag,char *val);
	bool remslot(char *t);
	bool fixslot(char *tag,char *val);
	char *idframe(char *f,char *id);
	char *getframe(char *frm);
	char *topframe(char *frm);
	char *nxtframe(char *frm);

	char *fndtag(char *a,char **t);
	char *synint(char *at,int *x);
	char *synlong(char *at,long *x);
	char *synnum(char *at,int *x);
	char *synvar(char *at,char *s,char **tag);
	char *syntag(char *at,char *s);
	char *synutag(char *at,char *s);

	void calc(char *s);

	void sockError(char *str);
	
	void post(char *s);
	void ppost(char *s,char *t);
	void pppost(char *r,char *s,char *t);

	// Cyc stuff
	void Cycsetvar(char *varname,char *value);
    void Cycloadvar(char *varname,char *defval);
private:
	int docmds(char *at);
	char *cmdlist;

	void stkpush(char *at);
	bool stkpop();
	bool stkret();

	void situate(char *at);
	void display(char *at);
	void assign(char *at);
	void branch(char *at);
	int  condite(char *at);

	int chkexp(char *s,bool chk);
		
	int  cmdhash(char *s);
	void cmda(char *s);
	void cmdb(char *s);
	void cmdc(char *s);
	void cmdd(char *s);
	void cmde(char *s);
	void cmdf(char *s);
	void cmdg(char *s);
	void cmdh(char *s);
	void cmdi(char *s);
	void cmdk(char *s);
	void cmdl(char *s);
	void cmdm(char *s);
	void cmdn(char *s);
	void cmdo(char *s);
	void cmdp(char *s);
	void cmdq(char *s);
	void cmdr(char *s);
	void cmds(char *s);
	void cmdu(char *s);
	void cmdw(char *s);

	int unknown(char *at);
	char *nxtcmd(char *at);

	bool infile(char *wd,char *fn);

	int cn;
	int dumm;

	char *xret;

/* system shared data */

	char *ptr;
	int retnum;

	char curfrm[64];
	char cursit[64];
	char tmpid[32];
	int  tmpcnt;
	Case *cmdCase;

	char *lastinput;
	char *lastreply;

	char *jflg;
	char *jfrm;
	int kcnt;
	
	bool aflg;	// used in getinput to use from facts
	bool xflg;	// exit script flag
	bool qflg;	// quit program flag
	bool dflg;	// display flag
	bool kflg;	// know situation tag flag
	bool pflg;  // pop stack flag?
		
	int pinpos;
	char *buf;
};

#endif // __INC_PUVM_H__
