/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

// scripts.h: interface for the Scripts class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCRIPTS_H__3EB0D0C4_1B5D_44B1_A200_7F592A50F92E__INCLUDED_)
#define AFX_SCRIPTS_H__3EB0D0C4_1B5D_44B1_A200_7F592A50F92E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Afxtempl.h"

#include "support.h"

//
// FRAMES
//

class Frame : public CObject
{
public:
	Frame();
	Frame(char *name,char *behavior);

// Attributes
public:
	CString m_name;
	CString m_behavior;

// Operations
public:
	void FormatFrame(CString& str);

// Implementation
public:
	virtual ~Frame();
};

typedef CTypedPtrMap<CMapStringToOb,CString,Frame*> CMapStringToFrame;

class Frames  
{
public:
	Frames();

// Operations
public:
	void Add(char *name,char *behavior);
	void RemoveAll();
	bool Remove(char *name);
	bool Seek(CString name);
	bool Find(char *name);
	bool GetFirst();
	bool GetNext();
	void FormatFrames(CString& str);
	void ListFrames(CString& str);

// Attributes
public:
	CMapStringToFrame m_mapStringToFrame;

	POSITION At;
	CString Key;
	Frame *curFrame;

// Implementation
public:
	virtual ~Frames();
};

//
// SCRIPTS
//

class Script : public CObject
{
public:
	Script();
	Script(char *name);

// Attributes
public:
	CString m_name;
	Frames m_frames;
	CStringList m_frameslist;

// Operations
public:
	void LoadFrames(char *text);
	void FormatScript(CString& str);
	void ListScript(CString& str);

// Implementation
public:
	virtual ~Script();
};

typedef CTypedPtrMap<CMapStringToOb,CString,Script*> CMapStringToScript;

class Scripts  
{
public:
	Scripts();

// Operations
public:
	void Add(char *name);
	void RemoveAll();
	bool Remove(char *name);
	bool Seek(CString name);
	bool Find(char *name);
	bool GetFirst();
	bool GetNext();
	void FormatScripts(CString& str);
	void ListScripts(CString& str);

// Attributes
public:
	CMapStringToScript m_mapStringToScript;

	POSITION At;
	CString Key;
	Script *curScript;

// Implementation
public:
	virtual ~Scripts();
};

#endif // !defined(AFX_SCRIPTS_H__3EB0D0C4_1B5D_44B1_A200_7F592A50F92E__INCLUDED_)
